/* 
 * EIO Piljardivoistluse Graafika Praktikum
 * 16. detsember 2007
 * (C) Konstantin Tretjakov
 * (C) Dan Bogdanov
 */
// Kasutame allegro teeki
#include "allegro.h"

/*
 * NB! Koodi lugemist tasub alustada funktsiooniga main. See asub koige lopus.
 * ---------------------------------------------------------------------------
 */


/*
 * Joonistamismeetod
 * Naitab kuidas bmp faile sisse laadida ja ekraanil naidata
 */
void draw() {
  clear_bitmap (screen);

  // Laadime failist pilti.
  BITMAP* background = load_bmp("foto.bmp", 0);
  
  if (background != 0) {
    // Joonistame teda "venitades" tervele ekraanile
    stretch_blit(background, screen, 0, 0, 845, 634, 0, 0, 800, 600);
  }

  // Tagaplaani peale joonistame mehikest. Mehike pildis on kasutatud nn. "magic pink"
  // varvi (RGB #FF00FF) naitamaks millised pikslid peavad labipaistvad olema.
  // (funktsioon draw_sprite teab et just see varv on labipaistvuse jaoks)
  BITMAP* telepoiss = load_bmp("telepoiss.bmp", 0);
  if (telepoiss != 0) {
    draw_sprite(screen, telepoiss, 500, 200);

    // Joonistame ka pooratud spraiti
    // Poordenurka naitame fixedpoint arvudes. 
    fixed spr_angle = itofix(64);
    
    // Paneme tahele et allegro kasutab efektiivsuse mottes binaarsysteemi
    // nurkade mootmiseks: taispoore (360 kraadi) on 256, taisnurk seega 64
    
    rotate_sprite (screen, telepoiss, 700, 200, spr_angle);
    spr_angle = itofix(78);
    rotate_sprite (screen, telepoiss, 600, 300, spr_angle);
    spr_angle = itofix(23);
    rotate_sprite (screen, telepoiss, 600, 100, spr_angle);
    
    // Joonistame ka poollabipaistvat spraiti
    set_trans_blender (128, 128, 128, 128);
    draw_trans_sprite(screen, telepoiss, 200, 200);
  }
}

/*
 * Programmi peameetod. Seadistab graafikasysteemi. 
 */
int main(int argc, char *argv[]) {
  allegro_init ();
  install_keyboard ();
  int bits = desktop_color_depth ();
  set_color_depth (bits);
  set_gfx_mode (GFX_AUTODETECT_WINDOWED, 800, 600, 0, 0);

  // Joonistame
  draw();

  // Ootame nupuvajutust ja lopetame
  while (!keypressed ());
  clear_keybuf ();
  return 0;
}
END_OF_MAIN ()

